

/*
AQUATSR.PRG
5/20/94   Software Evolution Corp.

A simple little TSR that shows just how easy it is to compile one of
these programs in FORCE 2.4c.

To see how useful this can be, the combination of TSR and datafile management
is a way to nail down business opportunities that are not otherwise open to
xBasers.  For example, we have EasySymbol 2.3 (otherwise known as the TSRFH)
that serves as an application-independent data lookup module giving insurers
online access to 13,000 rating symbols for different makes and models of cars
since 1980.... the TSR is completely independent of the 'underlying' app and
at the same time requires only that the underlying app _not_ use either the
<Sh-F1> or <Ctrl-F1> as hotkeys.  In return, the insurer gets cutting-edge
technology and data and has _no_ development expense.

In addition, since the functionality provided is generic and independent of
even the language or dialect of the underlying application (all we have to
do in that TSR is run a virtual list based on a dbf file and stuff the DOS
keyboard buffer with the two-digit symbol for the selected vehicle), we can
naturally use the same product over and over and over again for different
insurer clients.   Ah, the TSR that laid the golden egg.

AQUATSR is by no means as complex or cool, but does show how easy it is!
*/
******************************************************************************


#include screen.hdr
#include tsr.hdr
#include system.hdr
#include keys.hdr
#include io.hdr

procedure WakeUpYouTurkey prototype
procedure OuttaHere prototype



procedure force_main         // OK let's rock

vardef
int     iOldRow
int     iOldCol
enddef


  DO scrn_bios                    // this forces the runtime engine
                                  // to read the BIOS row/col positions

  iOldrow := row()                 //save cursor position going in
  iOldcol := col()

  do save_screen                  // and the screen too

  if .not. tsr_install( 365 )     // OK, check to see if our multiplex ID
                                  // exists (if it does, we're already loaded)
                                  // into memory

  else
                                  //  multiplex ID is OK so see if we can
                                  //  successfully load procedures to call
                                  //  i.e.: did both activate and unload
                                  //        procedures install successfully?

        if proc_entry( WakeUpYouTurkey, "<Alt><F1>", &TSR_CALL_ANY ) .and. ;
        proc_entry( OuttaHere, "<Ctrl><F10>", &TSR_CALL_ANY )

        
      *-----put cursor back where it was, thanks very much
                clear
                @ 10, 20 ??"TSR is now loaded - press <Alt-F1> to activate"
                @ 11, 20 ??"or <Ctrl_F10> to unload from memory"

                delay(10)

                do restore_area
                @ iOldRow, iOldCol

      *-----go tsr and allocate enough memory (in this case, 4096 bytes is
      *     a gracious plenty
               TSR(4096)   //OK, we're done!

        else
                clear
                @ 12,20 ?? "Could not load procedures;  check things out"
                delay(10)
        endif


  ENDIF

  do restore_area

  @ iOldRow, iOldCol

  quit


ENDPRO

*************************************************

// this procedure is called by the code above when the <Alt-F1> hotkey
//      combination is pressed.....


procedure WakeUpYouTurkey

vardef
int     iOldRow
int     iOldCol
enddef


  iOldrow := row()                 //save cursor position going in
  iOldcol := col()

  do save_screen                  // and the screen too

clear

@ 12, 20 ?? "OK, I'm up now!  I swear!  I'm out of bed!"
delay(10)

do restore_area                   // now put screen and cursor back
@ iOldRow, iOldCol

return
endpro

*****************************************************************************

// this procedure unloads the TSR from memory when the <Ctrl-F10> is pressed

procedure OuttaHere


vardef
int     iOldRow
int     iOldCol
enddef

  iOldrow := row()                //save cursor position going in
  iOldcol := col()

  do save_screen                  //and the screen too

clear
@ 12, 20 ?? "OK, OK, I'm going...."

unload_tsr()                      //now we're unloaded

do restore_area                   //now put screen and cursor back...
@ iOldRow, iOldCol

QUIT                             //close down, let's go home.
endpro
